package ssw.mj;

import java.io.BufferedReader;
import java.io.PrintWriter;
import java.io.Reader;

/**
 * The Scanner for the MicroJava Compiler.
 *
 * @author AW
 */
public class Scanner {
	private static final char EOF = '\u0080';
	private static final char CR = '\r';
	private static final char LF = '\n';

	private static Reader in;
	private static PrintWriter out;

	/** Lookahead character. (= next (unhandled) character in the input stream) */
	private static char ch;

	/** Current line in input stream. */
	private static int line;

	/** Current column in input stream. */
	private static int col;

	/** Initializes the scanner. */
	public static void init (Reader r) {
		init(r, new PrintWriter(System.out, true));
	}

	public static void init (Reader r, PrintWriter w) {
		in = new BufferedReader(r);
		out = w;
		line = 1; col = 0;
		nextCh();  // read 1st char into ch, incr col to 1
	}

	/** 
	 * Reads next character from input stream into ch.
	 * Keeps pos, line and col in sync with reading position.
	 */
	private static void nextCh () {
		ch = EOF;  // TODO: replace with your own code
	}

	/** 
	 * Returns next token.
	 * To be used by parser.
	 */
	public static Token next () {
		return new Token(Token.eof, 1, 1);  // TODO: replace with your own code
	} // next()
	
	/** 
	 * Prints error message of the format<br>
	 * <code>-- line <i>line no.</i>, col <i>column no.</i>: 
	 * <i>message</i></code><br>	
	 */
	private static void error (String msgKey, String postfix) {
		if (out != null) {  // testing scanner alone
			StringBuffer msg = new StringBuffer();
			msg.append("-- line ");
			msg.append(line);
			msg.append(", col ");
			msg.append(col);
			msg.append(": ");
			if (msgKey != null) msg.append(Messages.getString(msgKey)); 
			msg.append(postfix);
			out.println(msg.toString());	
		}	/* else  // testing scanner with a parser
			 * Parser.Errors.error("", msgKey, postfix);
			 * 
			 * TODO: remove this comment for UE 3 !!!
			 */
	}

} // end Scanner
